
#    Note:  This is loaded into the namespace LOST

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable Line_count 0

    variable JS ""

    variable allmodules 0
    variable module_list ""
      set BAK $::AIDA::FEE64   ;#   save
	foreach item $::AIDA::ModuleMenu {
		set ::AIDA::FEE64 $item	
    		variable Name$item "$item"
     		variable ASIC$item 0
     		variable CT$item 0
     		variable DISC$item 0
     		variable BUFF$item 0


     		variable ASICdiff$item 0
     		variable CTdiff$item 0
     		variable DISCdiff$item 0
     		variable BUFFdiff$item 0


   		variable ASICOld$item [ ReadAIDARegister 0x30C ]
     		variable CTOld$item [ ReadAIDARegister 0x311 ]
     		variable DISCOld$item [ ReadAIDARegister 0x503 ]
     		variable BUFFOld$item [ ReadAIDARegister 0x60d ]

	}

      set ::AIDA::FEE64 $BAK   ;#   restore

   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
   }


   proc do_redisplay {} {

     variable module_list
     variable allmodules 

	

      set BAK $::AIDA::FEE64   ;#   save

	foreach item $::AIDA::ModuleMenu {
 		set ::AIDA::FEE64 $item		
     		variable ASICdiff$item
     		variable CTdiff$item
     		variable DISCdiff$item
     		variable BUFFdiff$item


     		variable ASIC$item
     		variable ASICOld$item
		set vl0 [ set ASICOld$item ]
		set vl1 [ ReadAIDARegister 0x30C ]
		set ASICdiff$item [ expr $vl1 - $vl0 ]
		if { $vl0 == $vl1 } {
			set ASIC$item "<font color=green>$vl0<\/font>"
		} else {
			set ASIC$item "<font color=red>$vl1<\/font>"
			set ASICOld$item $vl1

		}

     		variable CT$item 
     		variable CTOld$item 
 		set vl0 [ set CTOld$item ]
		set vl1 [ ReadAIDARegister 0x311 ]
		set CTdiff$item [ expr $vl1 - $vl0 ]
		if { $vl0 == $vl1 } {
			set CT$item "<font color=green>$vl0<\/font>"
		} else {
			set CT$item "<font color=red>$vl1<\/font>"
			set CTOld$item $vl1

		}
    		variable DISC$item 
    		variable DISCOld$item 
		set vl0 [ set DISCOld$item ]
		set vl1 [ ReadAIDARegister 0x503 ]
		set DISCdiff$item [ expr $vl1 - $vl0 ]
		if { $vl0 == $vl1 } {
			set DISC$item "<font color=green>$vl0<\/font>"
		} else {
			set DISC$item "<font color=red>$vl1<\/font>"
			set DISCOld$item $vl1

		}
    		variable BUFF$item 
    		variable BUFFOld$item 
		set vl0 [ set BUFFOld$item ]
		set vl1 [ ReadAIDARegister 0x60D ]
		set BUFFdiff$item [ expr $vl1 - $vl0 ]
		if { $vl0 == $vl1 } {
			set BUFF$item "<font color=green>$vl0<\/font>"
		} else {
			set BUFF$item "<font color=red>$vl1<\/font>"
			set BUFFOld$item $vl1

		}

	}
      set ::AIDA::FEE64 $BAK   ;#   restore


   }

   proc do_setOpt900 {i vl} {
      variable allmodules

    }

   proc FORCE {} {
      variable allmodules
      variable module_list

   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPT900     {do_setOpt900 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

    do_redisplay

}   ;# end of if {$started == 0}




