


# variable Started 0

if {![info exists Started]} {variable Started 0}


if {$Started != 0} {

     variable JS ""
     variable LogFlag



     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
    

}

if {$Started == 0} {           ;#  first time load code and define local variables

#
    set Started 1

	variable console { "Nothing Received" }
	variable USBList { }
	variable channelId 0
	variable USB_Selected 0
     variable file_base "/home/pi/logs"
     variable Usb_Logfile ""
     variable Usb_LogDir ""
     variable Trigger_list { ERROR  error  panic Bug sig: }
	 variable log_list { }
	 variable report_List
	 variable Aida_titles
	 variable report_run 0

proc show_variables {} {
	variable console
	variable Trigger_list
	
#	InsertLog "console => $console"
	InsertLog "$Trigger_list"
	
}

proc do_Parse {} {
	variable Usb_Logfile

	variable console

	set filename $Usb_Logfile
	set console {}  
	set z [catch {open $filename r } m]
	if {$z != 0} { InsertLog "failed to open $filename for read => $m"	}
	set fileId $m
	set z [catch {read $fileId} m]
	if {$z != 0} {InsertLog "failed to read $filename => $m"}
	set logList [ split $m " " ]
	lappend console "Step 1\n"
	set list_length [ llength $logList ]
#	InsertLog "File $filename has $list_length words"
	lappend console "Step 2\n"
	set IPlist [ lsearch -all $logList DHCP ]
	set IP_len [ llength $IPlist ]
	set last [ expr $IP_len - 1 ]
	set ip_place [ expr [ lindex $IPlist $last ]  + 14 ]
	set My_IP [ lindex $logList $ip_place ]
#	InsertLog "$IPlist"
	set ip_place [ expr [ lindex $IPlist $last ]  + 21 ]
	set My_name [ lindex $logList $ip_place ]
	
	set panics [ llength [ lsearch -all $logList panic ] ]

	set last [ lrange $logList [ expr $list_length - 50 ]  end ]
#		set last_list [ split $last "." ]
	set last_search [ llength [ lsearch -all $last custom ] ]
	if { $last_search == 1 } {
		set status "Finished OK"
	} else {
		set status "Not Finished"			
	}
#		InsertLog "Found $IPlist places where DHCP occurs in $device"
#		InsertLog "My IP is  $My_IP\nMy name is $My_name\nLast_search = $last_search"
	lappend console "$filename =>  last $My_name => last $My_IP ; #panics => $panics ; $status \n"

}

proc do_BootError {} {
	variable Usb_Logfile

	variable console

	set filename $Usb_Logfile
	set console {"This report shows the number of occurrences of the two words error and ERROR in the log since the start of the most recent startup\n\n"} 
	lappend console "If there is a count > 0 then I suggest the logfile is inspected to determine the problem\n\n"

	set z [catch {open $filename r } m]
	if {$z != 0} {InsertLog "failed to open $filename for read => $m"}
	set fileId $m
#		lappend console "\n File $filename opened \n"
	set z [catch {read $fileId} m]
	if {$z != 0} {
		puts stderr "failed to read $filename => $m"
		lappend console "Failed to read file => $z\n"
	}
	set logList [ split $m " " ]
	set list_length [ llength $logList ]
#		lappend console "Length of log list is $list_length\n"		
#		InsertLog "Device $device has $list_length words"
	set Startlist [ lsearch -all $logList Version]
	set Start_len [ llength $Startlist ]
	set flag 0
	while { $flag == 0 } {
		set last_start [ expr $Start_len - 1 ]
		set Start_place [ expr [ lindex $Startlist $last_start ]  ]
		set My_Start [ lindex $logList $Start_place ]
		set Next_entry [ lindex $logList [ expr $Start_place + 1 ] ]
		if { $Next_entry == "1.00" } {
			set flag 1 
		} else {
			set Start_len [ expr $Start_len - 1 ]
			if { $Start_len == 0 } {
				lappend console "Start not found \n"
				set flag 2
			}
		}
	}	
#		Having found the start of the last boot 
#	    Now to look for things to report if flag is 1 then we are ok to search here.
	if { $flag == 1 } {
		set error_Count [ llength [ lsearch -all -start $Start_place $logList error ] ]
		set ERROR_Count [ llength [ lsearch -all -start $Start_place $logList ERROR ] ]
	} else {
		set error_Count 0
		set ERROR_Count 0
	}
#		
#		set last_search [ llength [ lsearch -all $last custom ] ]
#		if { $last_search == 1 } {
#			set status "Finished OK"
#		} else {
#			set status "Not Finished"			
#		}
#		InsertLog "Found $IPlist places where DHCP occurs in $device"
#		InsertLog "My IP is  $My_IP\nMy name is $My_name\nLast_search = $last_search"
#		lappend console "$device =>  $last_start , $Start_place , $My_Start, $Next_entry \n"
	lappend console "$filename =>  error : $error_Count ; ERROR : $ERROR_Count \n"

}

proc do_Trigger_Words {} {
	variable Usb_Logfile
	variable Trigger_list 
	variable console
	variable report_List
	variable log_list
	variable report_run
	variable Aida_titles
	

	set console {"Trigger words are :- "} 
	foreach trigger $Trigger_list {
		lappend console " $trigger "
	}
	lappend console "\n\n" 
	foreach entry $log_list {
		set Usb_Logfile $entry
		do_Trigger_Obtain
	}
	set report_run 1 
}

proc do_Trigger_Obtain { } {
	variable Usb_Logfile
	variable Trigger_list 
	variable console
	variable report_List
	variable Aida_titles
	
	set filename $Usb_Logfile
	
	set report_List($Usb_Logfile) { }
	set Aida_titles($Usb_Logfile) { }

	set z [catch {open $filename r } m]
	if {$z != 0} {InsertLog "failed to open $filename for read => $m"}
	set fileId $m
	lappend console "\n File $filename opened \n"
	set z [catch {read $fileId} m]
	if {$z != 0} {
		InsertLog "failed to read $filename => $m"
		lappend console "Failed to read file => $z\n"
	}
	set logList [ split $m " " ]
	lappend console "Step 1\n"
	set list_length [ llength $logList ]
#	InsertLog "File $filename has $list_length words"
	lappend console "Step 2\n"
	set IPlist [ lsearch -all $logList DHCP ]
	set IP_len [ llength $IPlist ]
	set last [ expr $IP_len - 1 ]
	set ip_place [ expr [ lindex $IPlist $last ]  + 14 ]
	set My_IP [ lindex $logList $ip_place ]
#	InsertLog "$IPlist"
	set ip_place [ expr [ lindex $IPlist $last ]  + 21 ]
	set My_name [ lindex $logList $ip_place ]
	set aida_Name [ string range  $My_name end-6 end-1 ]
	
	lappend console " my name is : $My_name , $aida_Name \n"
	lappend Aida_titles($Usb_Logfile) $aida_Name
	
	
	
	set logList [ split $m "\n" ]
	set list_length [ llength $logList ]
#	lappend console "Length of log list is $list_length\n"		
#		InsertLog "Device $device has $list_length words"
#	    Now to look for things to report if flag is 1 then we are ok to search here.
	foreach report $logList {
		set repLine [ split $report " " ]
		set trig_Count 0
		foreach trigger $Trigger_list {
			set trig_Count [ expr $trig_Count + [ llength [ lsearch -all $repLine $trigger ] ] ]
		}
		if { $trig_Count > 0 } {
			lappend console "     $repLine\n"
			lappend report_List($Usb_Logfile) $repLine
		}
	}
	lappend console "$filename =>  Done \n"

}
	proc do_LoadFile { usb_dir } {
	    variable Usb_Logfile
	    variable Usb_LogDir
		variable console
		variable log_list
		
		set console {}
		lappend console "Hello from do_LoadFile\n"
		set Usb_LogDir $usb_dir
		set log_list [ glob -nocomplain -directory $usb_dir ttyUSB* ]
		set logs_count [llength $log_list ]
		lappend console "found $logs_count logs to parse\n"
		if { $logs_count == 0 } {
			lappend console "No log files found in $usb_dir, found the following files \n"
			set dir_list  [ glob -nocomplain -directory $usb_dir * ]
			foreach entry $dir_list {
				lappend console $entry 
				lappend console "\n"
			}
		} else {
			foreach log $log_list {
				lappend console $log
				lappend console " \n"
			}
		}
	}
	
	proc do_Coincidences {} {
#	variable Usb_Logfile
#	variable Trigger_list
	variable log_list 
	variable console
	variable report_List
	variable report_run
	variable Aida_titles
	
	set found_time { }
	set console { }
	
#	lappend console "Hello from Coinc\n"
	
	if { $report_run == 0 } {
		lappend console " Operate the Check USB log files for Trigger words first\n"
		break
	}
	foreach entry $log_list {
		if { [ info exists report_List($entry)] } {
			set entry_name [  lindex [ split $entry "/" ] end ]
#			lappend console "Hello again from $entry_name \n"
			set Aida_name [ set Aida_titles([ set entry ]) ]
			set reports [set report_List([ set entry ]) ]
			if { [ llength $reports ] == 0 } { 
				continue 
			}
			foreach item $reports {
				set flag 0 ;  # so each time is tested only once 
				set rep_date [ string is integer  [ string index $item 0 ] ]
				if { $rep_date == 1 } {
					set ptime  [ string range $item 0 7 ]
					set done_this 0
					foreach f_time $found_time {
						if { [ string equal $ptime $f_time ] } {
							set done_this 1
							break
						}
					}
					if { $done_this } { continue }
					foreach test_entry $log_list { ; 												# each of the log files 
						if { $test_entry != $entry  &&  [ info exists report_List($test_entry)]} {
							set this_reports [ set report_List([set test_entry])]
							if { [ llength $reports ] == 0 } { continue }
							foreach this_item $this_reports { ;  									# each of the Trigger reports
								set this_rep_date [ string is integer  [ string index $this_item 0 ] ]
								if { $this_rep_date == 1 } {
									set this_ptime  [ string range $this_item 0 7 ]
									if {[ string equal $this_ptime $ptime] } {
										set this_entry_name [  lindex [ split $test_entry "/" ] end ]
										set this_Aida_name [ set Aida_titles([ set test_entry ]) ]
										if { $flag == 0 } {
											lappend console "\nFound a match for Trigger Report from $Aida_name\n       => $item\n$this_Aida_name => $this_item\n"
											set flag 1 ; # to indicate found a match
										} else {
											lappend console "$this_Aida_name => $this_item\n"
										}
										break
									}
								}
								
							}

						}
					}
					if { $flag } {
						lappend found_time $ptime
						lappend console " \n"
					}
				} 
			}
		} else {
			lappend console "no entry for log file $entry\n"
		}
	}
	
}
	
    proc do_click {} {
	variable cgidata
	variable Started
	variable LogFlag
	variable ShowLogFlag
	variable JS
	variable USB_Selected

	set cgidata [ncgi::nvlist]
	
	if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [lindex $cgidata 1]
		set vl [second [lindex $cgidata 1]]
		
		
		switch -glob [lindex $w 0] {
		    
		    RESET    {set Started 0; return}
		    CLEAR    {EmptyLog}
		    ELOG     {PrintLog}
		    RELOAD   {variable Reloading; set Reloading 1}
		    VARIABLES {show_variables}

		    GETUSB    { do_GetUSB }
		    CONUSB    { do_Connect }
		    PARSE    { do_Parse }
			BERROR    { do_BootError }
		    TTYSEL    { set USB_Selected $vl }
		    LOAD	  { do_LoadFile $vl }
		    PWORDS	  { do_Trigger_Words }
		    PCOINC	  { do_Coincidences }

		    HIDE     {set ShowLogFlag 0}
		    SHOW     {set ShowLogFlag 1}
		    LOGON    {set LogFlag 1}
		    LOGOFF   {set LogFlag 0}
		    
		    HELP     {
			variable HelpTopic
			set HelpTopic $vl
			do_help
		    }
		    undefined {}
		    default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata" }
		}
	    }
	}
    }
    set html ""

}   ;# end of if {$Started == 0}



