
#    Note:  This is loaded into the namespace WAVEX

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable Line_count 0

    variable JS ""

    variable allmodules 0
    variable module_list ""
      set BAK $::AIDA::FEE64   ;#   save
	foreach item $::AIDA::ModuleMenu {
		set ::AIDA::FEE64 $item	
    		variable Name$item "$item"
		foreach thing { 1 2  } {
     		
			variable Counter[set item]Count$thing 0
			foreach part { 0 16 } {
				variable Counter[set item]Count[set thing]$part 0
				 
			}
		}
  
	}

      set ::AIDA::FEE64 $BAK   ;#   restore

   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
   }


   proc do_redisplay {} {

     variable module_list
     variable allmodules 

      set BAK $::AIDA::FEE64   ;#   save

	foreach item $::AIDA::ModuleMenu {
 		set ::AIDA::FEE64 $item		
		foreach thing { 1 2  } { ; # declare the variables to be used
     		
			variable Counter[set item]Count$thing
			foreach part { 0 16 } {
				variable Counter[set item]Count[set thing]$part 0 
			}
		}
  
		foreach thing { 1 2  } {

			set val [ ReadAIDARegister [ expr 0xa00 + $thing]  ]

			
			if { $thing == 1 } {
				set Counter[set item]Count$thing "<font color=green>$val<\/font>"
				set state "" 
				if { ( $val & 0xF ) == 1 } { set state "Waiting for action" }
				if { ( $val & 0xF ) == 11 } { set state "Waiting for DMA" }
				set Counter[set item]Count[set thing]0 [ format " %d $state" [ expr  $val  &  0xF ]]

				set Counter[set item]Count[set thing]16 [ format " %d " [ expr ( $val >> 16 ) & 0x3F ] ]
			
			}
			if { $thing == 2 } {
				set state ""
				if { ( $val >> 14 ) & 1 == 1 } { set state "Pause" }
				if { ( $val >> 13 ) & 1 == 1 } { set state "[set state ] and Time fifo full" }
				
				set Counter[set item]Count$thing [ format "%08X: $state" $val ]

			}
			
 		}	
 
	}
      set ::AIDA::FEE64 $BAK   ;#    restore


   }

   proc do_setOpt900 {i vl} {
      variable allmodules

    }

   proc FORCE {} {
      variable allmodules
      variable module_list

   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPT900     {do_setOpt900 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

    do_redisplay

}   ;# end of if {$started == 0}




